//template <class Key, class T> map

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
using namespace std;

int main (int argc, char *argv[]) {
  
  // container associativo - valor das chaves (Key)
  // acesso aos elementos e dado basicamente pelas chaves (conteudo)
  // implementado usando uma arvore binaria de busca
  map<char, int> mapa;
  //map<char, set<int>> mapa2;
  map<char, int>::iterator it;
  
  // versao 1 - insere um par (chave,valor)
  mapa.insert( pair<char,int>('a',10) );
  mapa.insert( pair<char,int>('z',100) );
  mapa.insert( pair<char,int>('c',30) );
  mapa.insert( pair<char,int>('b',25) );
  mapa.insert( pair<char,int>('e',25) );
  mapa.insert( pair<char,int>('g',15) );
  mapa.insert( pair<char,int>('i',225) );
  mapa.insert( pair<char,int>('f',15) );
  
  cout << "conteudo de mapa: " << endl;
  for (it = mapa.begin(); it != mapa.end(); it++) {
     cout << (*it).first << "->" << (*it).second << " "; 
  }
  cout << endl;
  
  map<int, set<char> > mapa2;
  map<int, set<char> >::iterator it2;
  set<char> conj1, conj2;
  set<char>::iterator itc;
  
  conj1.insert('A');
  conj1.insert('B');
  conj1.insert('C');
  
  conj2.insert('x');
  conj2.insert('y');
  conj2.insert('z');
  
  // versao 1 - insere um par (chave,valor)
  mapa2.insert( pair<int, set<char> >(1,conj1) );
  mapa2.insert( pair<int, set<char> >(2,conj2) );
  
  cout << "conteudo de mapa2: " << endl;
  for (it2 = mapa2.begin(); it2 != mapa2.end(); it2++) {
      cout << (*it2).first << " -> "; 
      for (itc=(*it2).second.begin(); itc!=(*it2).second.end(); itc++) {
	cout << (*itc) << " "; 
      }
      cout << endl;
  }
  cout << endl;

  
  return 0;   
}
